/**
 * Created at 16/5/15.
 * @Author Ling.
 * @Email i@zeroling.com
 */
const babel = require('babel-core');
import 'should';
import babelPluginNodejsImportImages from '../src';

describe('babel-plugin-nodejs-import-images', () => {
    describe(`transform: import fs from 'fs'`, () => {
        it(`should not be handled`, () => {
            babel.transform(`import fs from 'fs'`, {
                plugins: [babelPluginNodejsImportImages]
            }).code
              .should.be.equal(`import fs from 'fs';`)
        });
    });

    describe(`transform: import img from './test.jpg'`, () => {
        it(`should be: const img = require('fs').readFileSync('./test.jpg');`, () => {
            babel.transform(`import img from './test.jpg'`, {
                plugins: [babelPluginNodejsImportImages]
            }).code
              .should.be.equal(`const img = require('fs').readFileSync('./test.jpg');`)
        });
    });

    describe(`transform: require('should');`, () => {
        it(`should not be handled`, () => {
            babel.transform(`require('should');`, {
                plugins: [babelPluginNodejsImportImages]
            }).code
              .should.be.equal(`require('should');`)
        });
    });

    describe(`transform: const img = require('./test.jpg')`, () => {
        it(`should be: const img = require('fs').readFileSync('./test.jpg');`, () => {
            babel.transform(`const img = require('./test.jpg')`, {
                plugins: [babelPluginNodejsImportImages]
            }).code
              .should.be.equal(`const img = require('fs').readFileSync('./test.jpg');`)
        });
    });

});
